package Grafo;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;

public class ArvoreDeZykov{
	
	private Grafo arvore;
	private int contracao, religacao;
	
	public ArvoreDeZykov(Grafo g){
		super();
		contracao = 0;
		religacao = 0;
		arvore = new GrafoDirecionado();
		arvore.adicionaVertice(new Vertice("raiz", g));
		construir(arvore);
	}

	private void construir(Grafo arvore) {
		int count = 0; // O nível da árvore é, no máximo, Cn,2. Count irá controlar a recursão.
		
	}
	
	public void contracao(Vertice v1, Vertice v2, GrafoNaoDirecionado g){
		Grafo novoGrafo = g.clone();

		for(Vertice v : v1.getAdjacentes())
			if(!v2.getAdjacentes().contains(v)){
				v2.adicionaAdjacente(v);
			}
		
		v2.setNome(v2.getNome() + " + " + v1.getNome());
		novoGrafo.removeVertice(v1.getNome());
		arvore.adicionaVertice(new Vertice("Contracao número " + contracao + "", novoGrafo));		
	}
	
	public void religacao(Vertice v1, Vertice v2, GrafoNaoDirecionado g){
		Grafo novoGrafo = g.clone();
		g.adicionaAresta(v1.getNome(), v2.getNome());
		
		arvore.adicionaVertice(new Vertice("Religação número " + religacao + "", novoGrafo));
	}

	public List<Vertice> procuraVerticeNaoConectados(Grafo g){
		List<Vertice> verticesNaoLigados = new ArrayList<Vertice>();
		Collection<Vertice> todosOsVertices = g.getTodosVertices();
		
		for(Vertice v1 : todosOsVertices){
			for(Vertice v2 : todosOsVertices)
				if(!v1.getAdjacentes().contains(v2) && !v1.equals(v2)){
					verticesNaoLigados.add(v1);
					verticesNaoLigados.add(v2);
					
					return verticesNaoLigados;
				}	
		}
		
		return verticesNaoLigados;
	}
	
	
}
