package Grafo;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

public abstract class Grafo {

	protected HashMap<String, Vertice> listaDeAdjacencias;
	
	protected Grafo(){
		listaDeAdjacencias = new HashMap<String,Vertice>();
	}
	
	public abstract Grafo clone();
		
	public void adicionaVertice(Vertice vertice){
		listaDeAdjacencias.put(vertice.getNome(), vertice);
	}

	public int ordem() {
		return listaDeAdjacencias.size();
	}

	public Collection<Vertice> getTodosVertices() {
		return listaDeAdjacencias.values();
	}

	public abstract boolean removeVertice(String nome);
	
	public Vertice obterUmVertice(){
		Iterator<Vertice> iterador = null;
		iterador = listaDeAdjacencias.values().iterator();
		Vertice vertice;
		int aleatorio = (int) ( Math.random() * (this.ordem()) );
		int cont = 0;
		while(iterador.hasNext()){
			vertice = iterador.next();
			if(cont == aleatorio){
				return vertice;
			}
			cont++;
		}
		
		return null;
	}

	public abstract boolean removeAresta(String nomeSaida, String nomeChegada);

	public abstract boolean adicionaAresta(String nomeSaida, String nomeChegada);
	
}
