package Grafo;

import java.util.HashMap;
import java.util.Iterator;

public class GrafoDirecionado extends Grafo{
	
	public boolean adicionaAresta(String nomeSaida, String nomeChegada) {
		Vertice saida, chegada;
		if(listaDeAdjacencias.containsKey(nomeSaida) && listaDeAdjacencias.containsKey(nomeChegada)){
			saida = listaDeAdjacencias.get(nomeSaida);
			chegada = listaDeAdjacencias.get(nomeChegada);
			
			saida.adicionaSucessor(chegada);
			chegada.adicionaAntecessor(saida);	
			
			return true;
		}
		
		return false;
	}

	public boolean removeAresta(String nomeSaida, String nomeChegada) {
		Vertice saida, chegada;
		if(listaDeAdjacencias.containsKey(nomeSaida) && listaDeAdjacencias.containsKey(nomeChegada)){
			saida = listaDeAdjacencias.get(nomeSaida);
			chegada = listaDeAdjacencias.get(nomeChegada);
			
			saida.removeSucessor(chegada);
			chegada.removeAntecessor(saida);	
			
			return true;
		}
		
		return false;
	}
	
	public boolean removeVertice(String nome) {
		Iterator<Vertice> iterador;
		Vertice vertice, verticeTemp = listaDeAdjacencias.get(nome);
		
		iterador = listaDeAdjacencias.values().iterator();
		while(iterador.hasNext()){
			vertice = iterador.next();
			if(vertice.getSucessores().contains(verticeTemp))
				removeAresta(vertice.getNome(), verticeTemp.getNome());
		}
	
		if(listaDeAdjacencias.containsKey(nome))
			listaDeAdjacencias.remove(nome);
				
		return true;
	}
	
	public Grafo clone(){
		Grafo g = new GrafoDirecionado();
		
		for(int i = 0; i < listaDeAdjacencias.size(); i++){
			g.adicionaVertice(listaDeAdjacencias.get(i));
		}

		return g;
	}
		
}
