package Grafo;

import java.util.HashMap;
import java.util.Iterator;

public class GrafoNaoDirecionado extends Grafo{

	public boolean removeAresta(String nomeSaida, String nomeChegada) {
		Vertice saida, chegada;
		if(listaDeAdjacencias.containsKey(nomeSaida) && listaDeAdjacencias.containsKey(nomeChegada)){
			saida = listaDeAdjacencias.get(nomeSaida);
			chegada = listaDeAdjacencias.get(nomeChegada);
			
			saida.removeAdjacente(chegada);	
			
			return true;
		}
		
		return false;
	}

	public boolean adicionaAresta(String nomeSaida, String nomeChegada) {
		Vertice saida, chegada;
		if(listaDeAdjacencias.containsKey(nomeSaida) && listaDeAdjacencias.containsKey(nomeChegada)){
			saida = listaDeAdjacencias.get(nomeSaida);
			chegada = listaDeAdjacencias.get(nomeChegada);
			
			saida.adicionaAdjacente(chegada);
			
			return true;
		}
		
		return false;
	}
	
	public boolean removeVertice(String nome) {
		Iterator<Vertice> iterador;
		Vertice vertice, verticeTemp = listaDeAdjacencias.get(nome);
		
		iterador = listaDeAdjacencias.values().iterator();
		while(iterador.hasNext()){
			vertice = iterador.next();
			if(vertice.getAdjacentes().contains(verticeTemp))
				removeAresta(vertice.getNome(), verticeTemp.getNome());
		}
	
		if(listaDeAdjacencias.containsKey(nome))
			listaDeAdjacencias.remove(nome);
				
		return true;
	}
	
	public Grafo clone(){
		Grafo g = new GrafoNaoDirecionado();
		Iterator<Vertice> iterador;
		Vertice vertice;
		
		iterador = listaDeAdjacencias.values().iterator();
		while(iterador.hasNext()){
			vertice = iterador.next();
			g.adicionaVertice(vertice);
		}

		return g;
	}

}
