package Grafo;

import java.util.ArrayList;
import java.util.List;

public class Vertice {
	private String nome;
	private Object valor;
	private List<Vertice> sucessores;
	private List<Vertice> antecessores;
	private List<Vertice> adjacentes;
	
	public Vertice(String nome) {
		antecessores = new ArrayList<Vertice>();
		sucessores = new ArrayList<Vertice>();
		adjacentes = new ArrayList<Vertice>();
		this.nome = nome;
	}
	
	public Vertice(String nome, Object valor) {
		antecessores = new ArrayList<Vertice>();
		sucessores = new ArrayList<Vertice>();
		this.nome = nome;
		this.valor = valor;
	}
	
	public String getNome(){
		return nome;
	}
	
	public Object getValor(){
		return valor;
	}

	public List<Vertice> getSucessores() {
		return sucessores;
	}
	
	public List<Vertice> getAntecessores(){
		return antecessores;
	}
	
	public void adicionaSucessor(Vertice v){
		sucessores.add(v);
	}
	
	public void adicionaAntecessor(Vertice v){
		antecessores.add(v);
	}

	public void removeSucessor(Vertice v) {
		sucessores.remove(v);
	}
	
	public void removeAntecessor(Vertice v){
		antecessores.remove(v);
	}

	public int grauDeEmissao() {
		return sucessores.size();
	}
	
	public int grauDeRecepcao(){
		return antecessores.size();
	}

	public void removeAdjacente(Vertice chegada) {
		adjacentes.remove(chegada);
		chegada.adjacentes.remove(this);
	}

	public void adicionaAdjacente(Vertice chegada) {
		adjacentes.add(chegada);
		chegada.adjacentes.add(this);		
	}

	public List<Vertice> getAdjacentes() {
		return adjacentes;
	}

	public void setNome(String string) {
		this.nome = string;
	}

}
