package Menu;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

import Grafo.ArvoreDeZykov;
import Grafo.Grafo;
import Grafo.GrafoDirecionado;
import Grafo.GrafoNaoDirecionado;
import Grafo.Vertice;

public class Main {

	static Scanner leitor = new Scanner(System.in);

	public static void main(String[] args) {
		int opcao;
		Grafo grafo = new GrafoNaoDirecionado();
		
		for(int i = 1; i <= 5; i++)
			grafo.adicionaVertice(new Vertice("Vértice " + i));
		
		grafo.adicionaAresta("Vértice 1", "Vértice 2");
		grafo.adicionaAresta("Vértice 1", "Vértice 3");
		grafo.adicionaAresta("Vértice 2", "Vértice 5");
		grafo.adicionaAresta("Vértice 3", "Vértice 5");
		grafo.adicionaAresta("Vértice 3", "Vértice 4");
		grafo.adicionaAresta("Vértice 3", "Vértice 2");
		grafo.adicionaAresta("Vértice 4", "Vértice 5");

		do{
			opcao = menu();

			switch(opcao){
			
			case 0: // Fecha
				break;
			
			case 1: //Adiciona vértice
				String nome;
				System.out.println("Entre com o nome do vértice: ");
				nome = leitor.nextLine();
				grafo.adicionaVertice(new Vertice(nome));
				break;
			
			case 2: // Remove vértice;
				boolean sucesso;
				System.out.println("Entre com o nome do vértice: ");
				nome = leitor.nextLine();
				sucesso = grafo.removeVertice(nome);
				if(!sucesso)
					System.out.println("Este vértice não existe\n");
				break;
				
			case 3: // Adiciona aresta
				String nomeSaida, nomeChegada;
				
				System.out.println("Entre com o nome do vértice de saída: ");
				nomeSaida = leitor.nextLine();
				System.out.println("Entre com o nome do vértice de chegada: ");
				nomeChegada = leitor.nextLine();
				sucesso = grafo.adicionaAresta(nomeSaida, nomeChegada);
				if(!sucesso)
					System.out.println("Vértice não existe\n");
				break;
				
			case 4: // Remover aresta
				System.out.println("Entre com o nome do vértice de saída: ");
				nomeSaida = leitor.nextLine();
				System.out.println("Entre com o nome do vértice de saída: ");
				nomeChegada = leitor.nextLine();
				sucesso = grafo.removeAresta(nomeSaida, nomeChegada);
				if(!sucesso)
					System.out.println("Aresta não existe\n");
				
				break;
				
			case 5: //Obter ordem
				System.out.println("Ordem: " + grafo.ordem() + "\n");
				break;
				
			case 6: //Obter todos os vértices
				Collection<Vertice> vertices = grafo.getTodosVertices();
				Iterator<Vertice> iterador = null;
				iterador = vertices.iterator();
				Vertice vertice;
				while(iterador.hasNext()){
					vertice = iterador.next();
					System.out.println(vertice.getNome() + "\n");
				}
				break;
				
			case 7: // Obter um vértice
				vertice = grafo.obterUmVertice();
				if(vertice != null)
					System.out.println(vertice.getNome());
				break;
				
			case 8: // Obter os sucessores de um vértice
				List<Vertice> sucessores;
				vertices = grafo.getTodosVertices();
				iterador = null;
				iterador = vertices.iterator();
				System.out.println("Entre com o nome do vértice: ");
				nome = leitor.nextLine();
				while(iterador.hasNext()){
					vertice = iterador.next();
					if(vertice.getNome().equals(nome)){
						System.out.println("Sucessores do vértice " + vertice.getNome() + "\n");
						sucessores = vertice.getSucessores();
						for(int i = 0; i < sucessores.size(); i++)
							System.out.println("     -     " + sucessores.get(i).getNome());
					}
				}
				break;
				
			case 9: // Obter os antecessores de um vértice
				List<Vertice> antecessores;
				vertices = grafo.getTodosVertices();
				iterador = null;
				iterador = vertices.iterator();
				System.out.println("Entre com o nome do vértice: ");
				nome = leitor.nextLine();
				while(iterador.hasNext()){
					vertice = iterador.next();
					if(vertice.getNome().equals(nome)){
						System.out.println("Antecessores do vértice " + vertice.getNome() + "\n");
						antecessores = vertice.getAntecessores();
						for(int i = 0; i < antecessores.size(); i++)
							System.out.println("     -     " + antecessores.get(i).getNome());
					}
				}
				break;
				
			case 10: // Obter grau de emissão de um vértice
				vertices = grafo.getTodosVertices();
				iterador = null;
				iterador = vertices.iterator();
				System.out.println("Entre com o nome do vértice: ");
				nome = leitor.nextLine();
				while(iterador.hasNext()){
					vertice = iterador.next();
					if(vertice.getNome().equals(nome)){
						System.out.println("Grau de emissão do vértice " + vertice.getNome() + " é " + vertice.grauDeEmissao() +"\n");
					}
				}
				break;
				
			case 11: // Obter o grau de recepção de um vértice
				vertices = grafo.getTodosVertices();
				iterador = null;
				iterador = vertices.iterator();
				System.out.println("Entre com o nome do vértice: ");
				nome = leitor.nextLine();
				while(iterador.hasNext()){
					vertice = iterador.next();
					if(vertice.getNome().equals(nome)){
						System.out.println("Grau de recepção do vértice " + vertice.getNome() + " é " + vertice.grauDeRecepcao() +"\n");
					}
				}
				break;
				
			case 12: // Imprimir o grafo
				vertices = grafo.getTodosVertices();
				iterador = null;
				System.out.println("*** Grafo ***\n");
				
				iterador = vertices.iterator();
				System.out.println("** Vértices **\n");
				while(iterador.hasNext()){
					vertice = iterador.next();
					System.out.println(vertice.getNome() + "\n");
				}
				
				System.out.println("\n** Arestas **\n");

				iterador = null;
				iterador = vertices.iterator();
				while(iterador.hasNext()){
					vertice = iterador.next();
					sucessores = vertice.getSucessores();
					if(sucessores.size() == 0)
						sucessores = vertice.getAdjacentes();
					if(sucessores.size() != 0){
						for(int j = 0; j < sucessores.size(); j++){
							System.out.println(vertice.getNome() + " -> " + sucessores.get(j).getNome() + "\n");
						}
						System.out.println("\n");
					}
						
				}
				break;	
			
			case 20: // Para testes
				ArvoreDeZykov teste = new ArvoreDeZykov(grafo);
				sucessores = teste.procuraVerticeNaoConectados(grafo); 
			
				for(int i = 0; i < sucessores.size(); i++){
					System.out.println("Vértice " + i + ": " + sucessores.get(i).getNome() + "\n");
				}
				
				if(sucessores.size() != 0)
				//	grafo = teste.religacao(sucessores.get(0), sucessores.get(1), (GrafoNaoDirecionado) grafo);
				
				break;
				
			}
		}while(opcao != 0);
		
	}

	private static int menu() {
		int opcao;

		System.out.println("\nO que fazer?" + "\n0 - Sair "
				+ "\n1 - Adicionar vértice" + "\n2 - Remover vértice"
				+ "\n3 - Adicionar aresta" + "\n4 - Remover aresta"
				+ "\n5 - Obter ordem" + "\n6 - Obter todos os vértices"
				+ "\n7 - Obter um vértice"
				+ "\n8 - Obter os sucessores de um vértice"
				+ "\n9 - Obter os antecessores de um vértice"
				+ "\n10 - Obter o grau de emissão de um vértice"
				+ "\n11 - Obter grau de recepção de um vértice"
				+ "\n12 - Mostrar o grafo"
				+ "\n20 - Teste");

		opcao = Integer.parseInt(leitor.nextLine());

		return opcao;
	}
}
